#ifndef OGSE_SSR_H
#define OGSE_SSR_H
uniform samplerCUBE s_env0;
uniform samplerCUBE s_env1;
float3 calc_ssr(float4 P, float3 N, float3 vreflect)
{
/*	float4 ScreenSpaceReflectionPostProcessPS(float2 tc : TEXCOORD0, float3 view_dir : TEXCOORD1) : SV_Target
	{
	float3 normal = GetNormal(g_buffer_tex.Sample(point_sampler, tc)); // eye space normal
	view_dir = normalize(view_dir); // eye space view direction
	
	float linear_depth = depth_tex.SampleLevel(point_sampler, tc, 0).x;
	float non_linear_depth = linear_depth_to_non_linear(linear_depth, near_q.x, near_q.y);
	float3 tex_pos = float3(tc, non_linear_depth); // let z component be projected nonlinear depth, so we can do linear interpolation in screen space
       
	float3 pos_es = view_dir * (linear_depth / view_dir.z);
	
	float3 reflect_vec = normalize(reflect(view_dir, normal)); // eye space reflect vector
	float4 proj_ray_end = mul(float4(pos_es + reflect_vec * ray_length, 1), proj);
	proj_ray_end.xyz /= proj_ray_end.w;
	float3 tex_reflect_vec = float3(TexCoordFromPos(proj_ray_end), proj_ray_end.z) - tex_pos;
	
	// the reflect vector completely perpendiculars to screen
	if (!any(tex_reflect_vec.xy))
	{
	return 0;
	}
	
	// try to compute the intersection point of reflection vector and screen edge
	float t1 = 1;
	if (tex_reflect_vec.x < 0)
	{
	t1 = -tex_pos.x / tex_reflect_vec.x;
	}
	else if (tex_reflect_vec.x > 1)
	{
	t1 = (1 - tex_pos.x) / tex_reflect_vec.x;
	}
	
	float t2 = 1;
	if (tex_reflect_vec.y < 0)
	{
	t2 = -tex_pos.y / tex_reflect_vec.y;
	}
	else if (tex_reflect_vec.y > 1)
	{
	t2 = (1 - tex_pos.y) / tex_reflect_vec.y;
	}
	
	float3 tex_offset = min(t1, t2) * tex_reflect_vec;
	
	float orientation_factor = dot(reflect_vec, float3(0, 0, 1));
	int num_steps = (int)lerp(max_samples, min_samples, abs(orientation_factor));
	
	float step = 1.0f / num_steps;
	float3 sample_step = tex_offset * step;
	
	int sample_index = 0;
	float3 cur_tex_pos = tex_pos;
	
	float t = 0;
	float2 pt1, pt2 = 0;
	
	while (sample_index < num_steps)
	{
	cur_tex_pos += sample_step;
	float cur_sample_depth = depth_tex.SampleLevel(point_sampler, cur_tex_pos.xy, 0).r;
	float cur_ray_march_depth = non_linear_depth_to_linear(cur_tex_pos.z, near_q.x, near_q.y);
	
	t += step;
	
	if (cur_ray_march_depth > cur_sample_depth)
	{
	sample_index = max_samples;
	pt2 = float2(cur_sample_depth, cur_ray_march_depth);
	}
	else
	{
	++ sample_index;
	pt1 = float2(cur_sample_depth, cur_ray_march_depth);
	}
	}
	
	float delta1 = pt1.x - pt1.y;
	float delta2 = pt2.x - pt2.y;
	float delta = delta1 - delta2;
	
	float2 sample_tex_pos;
	if (delta2 == 0)
	{
	sample_tex_pos = tex_pos.xy + tex_offset.xy;
	}
	else
	{
	t = (delta1 * t - delta2 * (t - step)) / delta;
	sample_tex_pos = tex_pos.xy + t * tex_offset.xy;
	}
	
	float reflect_dir_fade_out_factor = clamp((reflect_vec.z + 0.5f) / 0.7f, 0, 1);
	
	float2 screen_edge = clamp(abs(sample_tex_pos - 0.5f) / 0.5f, 0, 1);
	float screen_edge_fade_out_factor = clamp((1 - max(screen_edge.x, screen_edge.y)) / ray_length_fadeout_factor, 0, 1);
	
	float3 clr = background_tex.Sample(point_sampler, sample_tex_pos).rgb;
	float alpha = (screen_edge_fade_out_factor * reflect_dir_fade_out_factor + reflect_dir_fade_out_factor * (1 - reflect_dir_fade_out_factor)) * (1 - roughness);
		
	return float4(clr, alpha);
	}
	*/
/*	InNormal = normalize(InNormal);
	ProjTex.xy = ProjTex.xy/ProjTex.w;
	float3 projViewPos = ProjTex.xyz;
	ProjTex.xy = ProjTex.xy*0.5 + 0.5;
	ProjTex.y = 1-ProjTex.y;

	// calculate reflection vector in view space
	float3 viewpos = mul(InPos,matView).xyz;
	float3 dir = viewpos.xyz;
	dir = reflect(viewpos.xyz,mul(InNormal,matView));
	dir = normalize(dir);
	
	// transform from view to screen space
	float4 tPos = mul(float4(viewpos+dir,1), matProj);
	tPos.xy = tPos.xy/tPos.w;
	float3 screenDir = tPos.xyz-projViewPos;
	screenDir *= 0.05/length(screenDir.xy); // start with a rather big length and refine if necessary

	// transform from screen to texture coordinates
	float3 screenPos = projViewPos+screenDir;
	screenPos.xy = screenPos.xy*0.5 + 0.5;
	screenPos.y = 1-screenPos.y;
	screenDir.x *= 0.5;
	screenDir.y *= -0.5;

	float depth;
	int max_num = 30;
	int done = 0;
	float3 oldPos = ProjTex;
	for(int i = 0; i < max_num; i++)
	{
		depth = tex2D(DepthSampler, screenPos.xy).x;
		if(depth < screenPos.z) // refine search
		{
			screenPos = oldPos;
			screenDir *= 0.5;
			screenPos += screenDir;
			done++;
		}
		else
		{
			oldPos = screenPos.xyz;
			screenPos.xyz += screenDir;
		}
	}
	if(done < 1) return 0;
	return tex2D(CameraSampler, screenPos.xy);*/
#ifndef SSR_DEBUG	
	half3	env0	= texCUBE (s_env0, vreflect);
	half3	env1	= texCUBE (s_env1, vreflect);
	half3	env	= lerp (env0,env1,L_ambient.w);
			return env*2;
#else
	//     
	float4 WorldPos = P;
	float4 ProjPos = mul(m_VP, WorldPos);
	float4 ScreenPos = convert_to_screen_space(ProjPos);
	ScreenPos /= ScreenPos.w;
	// 1.      
	float3 WorldReflect = reflect(normalize(WorldPos - eye_position), N);
	WorldReflect = normalize(WorldReflect);
	
	// 2.    proj space
	float3 WorldReflectedPoint = WorldReflect + WorldPos;
	float4 ProjReflectedPoint = mul(m_VP, float4(WorldReflectedPoint, 1));
	float4 ScreenReflectedPoint = convert_to_screen_space(ProjReflectedPoint);
	ScreenReflectedPoint /= ScreenReflectedPoint.w;
//	return ScreenReflectedPoint;
	// 3.    
	int num_samples = 10;  //  - ,      
	float4 SampleProjVec = ScreenReflectedPoint - ScreenPos;
	SampleProjVec /= length(SampleProjVec.xy);
	SampleProjVec /= num_samples;
	// 4.      
	float3 Last = ScreenPos.xyz;
	float3 Curr = (Last + SampleProjVec).xyz;
//	Curr = convert_to_screen_space(float4(Curr, 1));
//	return tex2D(s_image, Curr.xy)*5;
	float3 SampleVec = SampleProjVec;//float3(SampleProjVec.x*0.5, -SampleProjVec.y*0.5, SampleProjVec.z);
	float3 SSR = float3(0.0h,0.0h,0.0h);
	int curr_sample = 0;
	// 5.   
	while (curr_sample < num_samples ) {
		float depth = tex2D(s_position, Curr.xy).z;
		if (depth < Curr.z) {
			Last = (Last + Curr)/2;
			SSR = tex2D(s_image, Last.xy);
			curr_sample += num_samples;
		} else {
			curr_sample += 1;
			Last = Curr;
			Curr += SampleVec;
		}
        if ((Curr.z < 0.0)) {
			// Debug: Show blue color
			SSR = float3(0.0, 0.0 ,1.0);
			curr_sample = num_samples + 1;
      } else if ((Curr.x < 0.0) || (Curr.x > 1.0) || (Curr.y < 0.0) || (Curr.y > 1.0)) {
			// Debug: Show red color
			SSR = float3(1.0, 0.0, 0.0);
			curr_sample = num_samples + 1;
        } else if ((num_samples - curr_sample) < 1) {
			// Debug: Show green color
			SSR = float3(0.0, 1.0, 0.0);
			curr_sample = num_samples + 1;
		}		
	}
	return SSR * 5;
#endif
}
#endif